<template>
  <form action="">
    <div class="row">
      <div class="col-md-6">
        <div class="form-group">
          <label for="">Nome</label>
          <input type="text" name="" id="" class="form-control" v-model="pessoa.nome" required>
        </div>
      </div>

      <div class="col-md-6">
        <div class="form-group">
          <label for="">Sobrenome</label>
          <input type="text" name="" id="" class="form-control" v-model="pessoa.sobrenome" required>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-md-6">
        <div class="form-group">
          <label for="">Email</label>
          <input type="email" name="" id="" class="form-control" v-model="pessoa.email" required>
        </div>
      </div>

      <div class="col-md-6">
        <div class="form-group">
          <label for="">Telefone</label>
          <input type="tel" name="" id="" class="form-control" v-model="pessoa.telefone">
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-md-6">
        <div class="form-group">
          <label for="">{{ pessoa.pessoaJuridica ? 'CNPJ' : 'CPF' }}</label>
          <div class="form-check float-right">
            <input type="checkbox" name="" id="pessoaJuridica" class="form-check-input" v-model="pessoa.pessoaJuridica">
            <label for="pessoaJuridica">Pessoa Jurídica?</label>
          </div>

          <input type="text" name="" max="14" id="" class="form-control" v-model="pessoa.cnpj" v-if="pessoa.pessoaJuridica">

          <input type="text" name="" min="11" id="" class="form-control" v-model="pessoa.cpf" v-else>
        </div>

      </div>
    </div>

    <div class="text-center">
      <button type="button" class="btn btn-primary mr-2" @click="onSave">Salvar</button>
      <button type="button" class="btn btn-danger" @click="onClear">Limpar</button>
    </div>
  </form>
</template>

<script>
import axios from 'axios'

export default {
  data () {
    return {
      pessoa: {}
    }
  },

  methods: {
    onClear () {
      this.pessoa = {}
    },

    async onSave () {
      try {
        if (this.pessoa.id) {
          await this.atualizar(this.pessoa)
        } else {
          await this.adicionar(this.pessoa)
        }

        this.$emit('refresh')

        this.pessoa = {}

        this.$root.notify({
          text: 'Comando executado com sucesso!',
          type: 'success'
        })
      } catch (error) {
        this.$root.notify({
          text: 'Ocorreu um erro na execução!',
          type: 'danger'
        })
      }
    },

    atualizar (pessoa = {}) {
      return axios.post(`/pessoa/${pessoa.id}`, pessoa)
    },

    setForm (data) {
      this.pessoa = Object.assign({}, data)
    },

    adicionar (pessoa) {
      return axios.post('/pessoa', pessoa)
    }
  }
}
</script>

<style>

</style>